package com.warewms.ams.ndc.domain;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import com.warewms.common.annotation.Excel;
import com.warewms.common.base.domain.BaseEntity;
import lombok.Data;
import lombok.EqualsAndHashCode;

import java.util.Date;
import java.util.HashMap;
import java.util.Map;

/**
 * ams任务列表对象 ams_task
 *
 * @author andy
 * @date 2022-08-08
 */
@Data
@EqualsAndHashCode(callSuper=false)
@TableName("ams_task")
public class AmsTask extends BaseEntity {
    private static final long serialVersionUID = 1L;

    //属性
    @TableField(exist = false)
    private Map<String, Object> attr = new HashMap<>();

    public AmsTask() {
        attr.put("id", getId());
        attr.put("task_no", getTaskNo());
        attr.put("iKey", getIkey());
        attr.put("aci_index", getAciIndex());
        attr.put("st_from", getStFrom());
        attr.put("st_to", getStTo());
        attr.put("priority", getPriority());
        attr.put("system_status", getSystemStatus());
        attr.put("event", getEvent());
        attr.put("server_ack", getServerAck());
        attr.put("aci_accept", getAciAccept());
        attr.put("is_delete", getIsDelete());
        attr.put("callBackUrl", getCallbackurl());
        attr.put("addtime", getAddtime());
        attr.put("addwho", getAddwho());
        attr.put("sys_name", getSysName());
        attr.put("device_name", getDeviceName());
        attr.put("business_type", getBusinessType());
        attr.put("ext1", getExt1());
        attr.put("ext2", getExt2());
        attr.put("ext3", getExt3());
        attr.put("height_level", getHeightLevel());
        attr.put("remark", getRemark());
        attr.put("roadway", getRoadway());
        attr.put("tier", getTier());
    }

    public String getStr(String feild) {
        Object obj = attr.get(feild);
        if (obj != null) {
            return obj.toString();
        } else {
            return "";
        }
    }

    public void init(){
        attr.put("id", getId());
        attr.put("task_no", getTaskNo());
        attr.put("iKey", getIkey());
        attr.put("aci_index", getAciIndex());
        attr.put("st_from", getStFrom());
        attr.put("st_to", getStTo());
        attr.put("priority", getPriority());
        attr.put("system_status", getSystemStatus());
        attr.put("event", getEvent());
        attr.put("server_ack", getServerAck());
        attr.put("aci_accept", getAciAccept());
        attr.put("is_delete", getIsDelete());
        attr.put("callBackUrl", getCallbackurl());
        attr.put("addtime", getAddtime());
        attr.put("addwho", getAddwho());
        attr.put("sys_name", getSysName());
        attr.put("device_name", getDeviceName());
        attr.put("business_type", getBusinessType());
        attr.put("ext1", getExt1());
        attr.put("ext2", getExt2());
        attr.put("ext3", getExt3());
        attr.put("height_level", getHeightLevel());
        attr.put("remark", getRemark());
        attr.put("roadway", getRoadway());
        attr.put("tier", getTier());
    }

    /**
     * $column.columnComment
     */
    @TableId(type = IdType.ASSIGN_ID)
    private Long id;

    /**
     * 任务编号
     */
    @Excel(name = "任务编号")
    private String taskNo;

    /**
     * $column.columnComment
     */
    @Excel(name = "${comment}", readConverterExp = "$column.readConverterExp()")
    private Long ikey;

    /**
     * $column.columnComment
     */
    @Excel(name = "${comment}", readConverterExp = "$column.readConverterExp()")
    private Integer aciIndex;

    /**
     * $column.columnComment
     */
    @Excel(name = "${comment}", readConverterExp = "$column.readConverterExp()")
    private Integer stFrom;

    /**
     * $column.columnComment
     */
    @Excel(name = "${comment}", readConverterExp = "$column.readConverterExp()")
    private Integer stTo;

    /**
     * $column.columnComment
     */
    @Excel(name = "${comment}", readConverterExp = "$column.readConverterExp()")
    private Integer priority;

    /**
     * $column.columnComment
     */
    @Excel(name = "${comment}", readConverterExp = "$column.readConverterExp()")
    private Integer systemStatus;

    /**
     * $column.columnComment
     */
    @Excel(name = "${comment}", readConverterExp = "$column.readConverterExp()")
    private Integer event;

    /**
     * $column.columnComment
     */
    @Excel(name = "${comment}", readConverterExp = "$column.readConverterExp()")
    private Integer serverAck;

    /**
     * $column.columnComment
     */
    @Excel(name = "${comment}", readConverterExp = "$column.readConverterExp()")
    private Integer aciAccept;

    /**
     * $column.columnComment
     */
    @Excel(name = "${comment}", readConverterExp = "$column.readConverterExp()")
    private Integer isDelete;

    /**
     * $column.columnComment
     */
    @Excel(name = "${comment}", readConverterExp = "$column.readConverterExp()")
    private String callbackurl;

    /**
     * $column.columnComment
     */
    @Excel(name = "${comment}", readConverterExp = "$column.readConverterExp()")
    private Date addtime;

    /**
     * $column.columnComment
     */
    @Excel(name = "${comment}", readConverterExp = "$column.readConverterExp()")
    private String addwho;

    /**
     * 调用系统名称
     */
    @Excel(name = "调用系统名称")
    private String sysName;

    /**
     * 设备名称
     */
    @Excel(name = "设备名称")
    private String deviceName;

    /**
     * 任务类型(01普通任务60进判断位90出判断位m释放判断位)
     */
    @Excel(name = "任务类型(01普通任务60进判断位90出判断位m释放判断位)")
    private String businessType;

    /**
     * $column.columnComment
     */
    @Excel(name = "${comment}", readConverterExp = "$column.readConverterExp()")
    private String ext1;

    /**
     * $column.columnComment
     */
    @Excel(name = "${comment}", readConverterExp = "$column.readConverterExp()")
    private String ext2;

    /**
     * $column.columnComment
     */
    @Excel(name = "${comment}", readConverterExp = "$column.readConverterExp()")
    private String ext3;

    /**
     * 1(低) 2(中) 3(高）
     */
    @Excel(name = "1(低) 2(中) 3(高）")
    private String heightLevel;

    /**
     * 巷道
     */
    @Excel(name = "巷道")
    private String roadway;

    /**
     * 层
     */
    @Excel(name = "层")
    private String tier;

    private String remark;
}
