package com.warewms.ams.ndc.service.impl;

import com.warewms.ams.ndc.common.ValType;
import com.warewms.ams.ndc.domain.AmsHexdefineDetail;
import com.warewms.ams.ndc.domain.AmsTask;
import com.warewms.ams.ndc.mapper.AmsHexdefineDetailMapper;
import com.warewms.ams.ndc.service.IAmsHexdefineDetailService;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.List;

/**
 * 任务定义（lp0-lp30）Service业务层处理
 * 
 * @author ruoyi
 * @date 2022-08-12
 */
@Service
@Slf4j
public class AmsHexdefineDetailServiceImpl implements IAmsHexdefineDetailService
{
    @Autowired
    private AmsHexdefineDetailMapper amsHexdefineDetailMapper;

    @Override
    public List<AmsHexdefineDetail> selectAmsHexdefineDetailByBusinessType(String businessType) {
        return amsHexdefineDetailMapper.selectAmsHexdefineDetailByBusinessType(businessType);
    }

    @Override
    public String concatOrder(AmsTask amsTask, List<AmsHexdefineDetail> amsHexdefineDetails) {
        StringBuffer sb = new StringBuffer();
        for (AmsHexdefineDetail basTask : amsHexdefineDetails) {
            //System.out.println(basTask.getColName());
            //字符串直接取数据库保存值
            if (basTask.getColType() == ValType.TEXT.getCode()) {
                //如果是数字需要进行转换
                if (basTask.getValType() == 2) {
                    sb.append(String.format("%04X", Integer.parseInt(amsTask.getStr(basTask.getColVal()))));
                } else {
                    sb.append(basTask.getColVal());
                }
            } else {
                //如果是绑定值需要从任务表中获取，如果是数字
                if (basTask.getValType() == 1) {
                    //如果是数字需要进行转换，Priority为2位其余4位
                    if (basTask.getColName().equals("Priority")) {
                        sb.append(String.format("%02X", Integer.parseInt(amsTask.getStr(basTask.getColVal()))+ 0x80));
                    }else {
                        sb.append(String.format("%04X", Integer.parseInt(amsTask.getStr(basTask.getColVal()))));
                    }
                } else {
                    sb.append(amsTask.getStr(basTask.getColVal()));
                }
            }
        }
        return sb.toString();
    }
}
